Subject: Re: [PATCH] ieee80211softmac: Fix errors related to the work_struct changes

From: Larry Finger <[email-masked]>
Date: Sun, 10 Dec 2006 22:24:27 -0600

Ulrich Kunitz wrote:
> The signature of work functions changed recently from a context
> pointer to the work structure pointer. This caused a problem in
> the ieee80211softmac code, because the ieee80211softmac_assox_work
> function has  been called directly with a parameter explicitly
> casted to (void*). This compiled correctly but resulted in a
> softlock, because mutex_lock was called with the wrong memory
> address. The patch fixes the problem. Another issue was a wrong
> call of the schedule_work function. Softmac works again and this
> fixes the problem I mentioned earlier in the zd1211rw rx tasklet
> patch. The patch is against Linus' tree (commit af1713e0).
> 
> Signed-off-by: Ulrich Kunitz <[email-masked]>

Thanks Ulrich for this patch. I had spent the better part of 2 days bisecting Linus's git tree 
trying to isolate the problem that kept the system from booting when my bcm43xx card was installed.

I thought that when someone _BROKE_ an interface with this kind of change, it was their duty to fix 
_ALL_ parts of the system that uses this facility. At a minimum, shouldn't all maintainers get a 
heads up? I don't subscribe to LKML, but I peruse the summary and I certainly do not recall seeing a 
warning that this change was coming.

Larry